chiark / gitweb /
el/dot-emacs.el: We depend on `mpc' macros at compile time.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=https://ftp.distorted.org.uk/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22   case "$1" in
23     -x) xstuff=t;;
24     -n) false=false;;
25     --) shift; break;;
26     -*) echo >&2 "$0: bad option"; exit 1;;
27     *) break;;
28   esac
29   shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41   echon="echo -n"
42   echoc=""
43 else
44   echon="echo"
45   echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51   GETURL="curl -fs -o"
52   echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54   GETURL="wget -q -O"
55   echo " wget."
56 else
57   echo " failed!"
58   echo >&2 "$0: failed to find URL fetcher"
59   exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67   $echon "  $i:$echoc"
68   if [ -d $HOME$sub/$i ]; then
69     echo " already exists."
70   else
71     mkdir -p $HOME$sub/$i
72     echo " done."
73   fi
74 done
75 echo "  all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82   mlib:crc-mktab
83   checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86   xtoys:xatom
87 "
88 for system in $systems; do
89   set -- $(echo $system | tr : ' ')
90   sys=$1 prog=$2
91   $echon "  $sys:$echoc"
92   if $false $prog >/dev/null 2>&1 --version; then
93     echo " already installed."
94   else
95     ( set -e
96       $echon " downloading$echoc"
97       cd $HOME$sub/src
98       rm -rf $sys.tar.gz $sys-$ver
99       $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100       $echon " unpacking$echoc"
101       dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102       gzip -cd $sys.tar.gz | tar xf -
103       $echon " configuring$echoc"
104       cd $dir
105       mkdir build
106       cd build
107       ../configure \
108         --prefix=$HOME$sub \
109         PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110         >>buildlog 2>&1
111       $echon " building$echoc"
112       make >>buildlog 2>&1
113       $echon " installing$echoc"
114       make install >>buildlog 2>&1
115       echo " done."
116     )
117   fi
118 done
119 echo "  all done."
120
121 ###--------------------------------------------------------------------------
122 ### Install global configuration.
123
124 echo -n "Installing dotfile configuration:"
125 if [ -f $HOME$sub/.mdw.conf ]; then
126   echo " already installed."
127 else
128   cp mdw.conf $HOME$sub/.mdw.conf
129   echo " done."
130 fi
131
132 ## Symlink the various dotfiles into place
133 dotfiles="
134   bash-profile:.bash_profile bash-logout:.bash_logout
135   bash-completion:.bash_completion bashrc inputrc
136   emacs emacs-calc vm gnus.el ercrc.el
137   vimrc mg zile lesskey sqliterc
138   parallel-config:.parallel/config
139   ipython-config.py:.ipython/profile_default/ipython_config.py
140   ipython-key-bindings.py:.ipython/profile_default/startup/50-key-bindings.py
141   ditz-config
142   mailrc signature muttrc
143   cgrc tigrc
144   gdbinit
145   guile
146   rcrc
147   toprc
148   mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
149   pulse-daemon.conf:.pulse/daemon.conf
150   aspell.conf
151   tclshrc:.tclshrc tclshrc:.wishrc
152   lisp-init.lisp:.cmucl-init.lisp
153     lisp-init.lisp:.sbclrc
154     lisp-init.lisp:.clisprc.lisp
155     lisp-init.lisp:.eclrc
156   swank.lisp
157   mdw-build.conf:.config/mdw-build.conf
158   w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
159   dircolors colordiffrc screenrc tmux.conf cvsrc indent.pro"
160 [ "$xstuff" ] && dotfiles="$dotfiles
161   xinitrc xsession xmodmap vncrc vncsession
162   fonts.conf
163   stalonetrayrc
164   putty-defaults:.putty/sessions/Default%20Settings
165   mdw.session:.config/gnome-session/sessions/mdw.session
166   eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
167   e-keybindings.cfg:.enlightenment/keybindings.cfg
168   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
169   e16-bindings:.e16/bindings.cfg
170   gtkrc-2.0
171   gtk3.css:.config/gtk-3.0/gtk.css
172   gtk3-settings.ini:.config/gtk-3.0/settings.ini"
173 echo "Installing dotfiles..."
174 for d in $dotfiles; do
175   target=.$d
176   case $d in
177     *:*) target=${d#*:} d=${d%%:*};;
178   esac
179   ft=$HOME$sub/$target
180   dir=${ft%/*}
181   mkdir -p $dir
182   ln -s $here/dot/$d $ft.new
183   mv $ft.new $ft
184   echo "  $target"
185 done
186 echo "  all done."
187
188 ## CPP-hack files which need it.
189 cppfiles=""
190 [ "$xstuff" ] && cppfiles="$cppfiles
191   Xdefaults"
192 echo "Hacking files with C preprocessor..."
193 defs="-DHOME=$HOME -DPROFILE=$here"
194 defs="$defs -DEMACSWD=$(bin/mdw-conf emacs-width 77)"
195 for c in $cppfiles; do
196   target=.$c
197   case $c in
198     *:*) target=${c#*:} c=${c%%:*};;
199   esac
200   ft=$HOME$sub/$target
201   dir=${ft%/*}
202   mkdir -p $dir
203   cpp -P $defs dot/$c -o $ft.new
204   mv $ft.new $ft
205   echo "  $target"
206 done
207 echo "  all done."
208
209 ## Substitute things which need substituting.
210 dotfilessubst="
211   gitconfig
212   mykermrc
213   pulse-default.pa.in:.pulse/default.pa"
214 echo "Installing dotfiles with substitutions..."
215 for d in $dotfilessubst; do
216   case $d in
217     *:*) target=${d#*:} d=${d%%:*};;
218     *) target=.$d d=$d.in;;
219   esac
220   ft=$HOME$sub/$target
221   dir=${ft%/*}
222   mkdir -p $dir
223   sed "
224 1i\\
225 ### generated by $here/setup; do not edit!\\
226
227 /@home@/ s\a\a$HOME\ag
228 /@profile@/ s\a\a$here\ag
229 /@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
230 " dot/$d >$ft.new
231   mv $ft.new $ft
232   echo "  $target"
233 done
234 echo "  all done."
235
236 ## Symlink backgrounds.
237 backgrounds=$(cd bg && echo *)
238 if [ "$xstuff" ]; then
239   echo "Installing backgrounds..."
240   for b in $backgrounds; do
241     for e in enlightenment e16; do
242       dir=$HOME$sub/.$e/backgrounds
243       t=$dir/$b
244       mkdir -p $dir
245       ln -s $here/bg/$b $t.new
246       mv $t.new $t
247     done
248     echo "  $b"
249   done
250   echo "        all done."
251 fi
252
253 ###--------------------------------------------------------------------------
254 ### Install useful scripts included in this package.
255
256 scripts="
257   mdw-editor
258   mdw-pager
259   mdw-conf
260   mdw-build mdw-sbuild mdw-sbuild-server
261   update-buildable-branch
262   emacsclient-hack
263   movemail-hack
264   sendmail-hack
265   aspell-hack
266   emerge-hack
267   lesspipe.sh
268   run-with-shell-env
269   start-ssh-agent
270   start-ssh-pageant
271   add-ssh-keys
272   svnwrap
273   guest-console
274   hyperspec"
275 [ "$xstuff" ] && scripts="$scripts
276   xinitcmd
277   un-backslashify-selection
278   lock-screen
279   xpra-start-xdummy
280   xshutdown"
281 echo "Installing scripts..."
282 mkdir -p $HOME$sub/bin
283 for s in $scripts; do
284   ft=$HOME$sub/bin/$s
285   ln -s $here/bin/$s $ft.new
286   mv $ft.new $ft
287   echo "  $s"
288 done
289 echo "  all done."
290
291 hacks="
292   ssh:ssh"
293 echo "Installing hacks..."
294 for h in $hacks; do
295   d=${h%%:*} h=${h#*:}
296   ft=$HOME$sub/bin/hacks/$d
297   mkdir -p $ft
298   ln -s $here/hacks/$h $ft/$h.new
299   mv $ft/$h.new $ft/$h
300   echo "  $d:$h"
301 done
302 echo "  all done."
303
304 ###--------------------------------------------------------------------------
305 ### Set up the Emacs config.
306
307 $echon "Finding a suitable emacs:$echoc"
308 emacs=no
309 for i in emacs24 emacs23 emacs22 emacs21 emacs; do
310   if type -p >/dev/null $i; then
311     emacs=$i
312     break
313   fi
314 done
315 if [ $emacs = no ]; then
316   echo " failed."
317   emacs=:
318 else
319   echo " $emacs."
320 fi
321
322 echo "Installing Emacs packages..."
323 emacspkg="
324   make-regexp
325   ew-hols
326   mdw-gnus-patch
327   git git-blame vc-git stgit
328   mdw-multiple-cursors
329   quilt"
330 for elib in $emacspkg; do
331   $echon "  $elib:$echoc"
332   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
333        (progn
334          (setq load-path (nconc load-path (list "~/lib/emacs")))
335          (kill-emacs (condition-case nil
336                          (progn (load-library "'"$elib"'") 0)
337                        (error 1))))'; then
338     echo " already installed."
339   else
340     if [ -f el/$elib.el ]; then
341       cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
342     else
343       $echon " downloading$echoc"
344       $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
345     fi
346     $echon " compiling$echoc"
347     (cd $HOME$sub/lib/emacs;
348       $emacs >/dev/null 2>&1 --no-site-file --batch \
349         --eval '(byte-compile-file "'"$elib.el"'")')
350     echo " done."
351   fi
352 done
353 echo "  all done."
354
355 $echon "Setting up Emacs configuration:$echoc"
356 $echon " linking$echoc"
357 for f in dot-emacs.el Makefile; do
358   set -- $(echo $link | tr : ' ')
359   ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
360   mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
361 done
362 $echon " compiling$echoc"
363 { cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
364 echo " done."
365
366 ###----- That's all, folks --------------------------------------------------